input SessionInput {
  topicsSession: [SessionContent]
}

input SessionContent {
  topicId: ID!
  topicActions: [ActionPoint!]
  trend: Int!
  overallRating: Int!
}

input ActionPoint {
  text: String!
  checked: Boolean!
}

input TeamInput {
  name: String!
  icon: String
  description: String
  topics: [ID!]
  permissions: [ID]
  members: [ID!]
  sessions: [SessionInput]
  unfinishedSectionVote: String
}

type Comment {
  text: String
  checked: Boolean
  _id: ID
}

input CommentInput {
  text: String
  checked: Boolean
  _id: ID
}

type Team {
  _id: ID
  topics: [Topic]
  name: String
  icon: String
  description: String
  admin: ID
  permissions: [ID!]
  members: [User]
  sessions: [Session]
  unfinishedSectionVote: String
  lastSession: [Session]
  editPermission: Boolean
  membersNumber: Int
}

type Sessions {
  sessions: [Session]
}

type Session {
  _id: ID
  topicsSession: [SessionContentType]
  createdAt: String
}

type SessionContentType {
  _id: ID
  topicActions: [Comment]
  trend: Int
  overallRating: Int
  topicId: ID!
  icon: String
  name: String
}

input SessionContentInput {
  _id: ID
  topicActions: [CommentInput]
  trend: Int!
  overallRating: Int!
  topicId: ID!
  icon: String
  name: String
}

type Mutation {
  createTeam(teamInput: TeamInput!): Team!
  createSession(
    sessionInput: SessionInput!
    teamId: ID!
    unfinishedSectionVote: String
  ): Sessions
  editTeam(teamId: ID!, teamInput: TeamInput!): Team!
  updateSession(
    teamId: ID!
    updatedSession: [SessionContentInput]
    currentSessionIndex: ID!
  ): Team!
  autosaveVoteSession(teamId: ID!, sessionContent: String!): Team
}

type Query {
  teams: [Team]!
  team(teamId: ID!): Team!
  sessions(teamId: ID!, limit: Int): [Session]
}
